﻿using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;


namespace SpaceShooter
{
    // =======================================================================
    // Enemy, klass för fiender
    // =======================================================================
    class Enemy : MovingObject
    {
        bool isAlive = true; // För att hålla koll på om fienden lever eller inte
        // =======================================================================
        // Enemy(), konstruktor för att skapa objektet
        // =======================================================================
        public Enemy(Texture2D texture, float X, float Y)
            : base(texture, X, Y, 6f, 0.3f)
        {
        }
        // =======================================================================
        // Update(), uppdaterar fiendens position
        // =======================================================================
        public void Update(GameWindow window)
        {
            // Flytta på fienden:
            vector.X += speed.X;
            // Kontrollera så fienden inte åker utanför fönstret på sidorna
            if (vector.X > window.ClientBounds.Width - texture.Width || vector.X < 0)
                speed.X *= -1; // Byt riktning på fienden
            vector.Y += speed.Y;
            // Gör fienden inaktiv om den åker ut där nere
            if (vector.Y > window.ClientBounds.Height)
                isAlive = false;
        }
        // =======================================================================
        // Egenskaper för Enemy
        // =======================================================================
        public bool IsAlive
        {
            get { return isAlive; }
            set { isAlive = value; }
        }
    }

}
